Index: TOOLS/WATER_BUDGET/nemo.py
===================================================================
--- TOOLS/WATER_BUDGET/nemo.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/nemo.py	(revision 6647)
@@ -22,6 +22,8 @@
 Periodicity and other stuff
 
+- Lots of tests for xarray object
+- Not much testerd for numpy objects
+
 olivier.marti@lsce.ipsl.fr
-'''
 
 ## SVN information
@@ -29,6 +31,7 @@
 __Date__     = "$Date$"
 __Revision__ = "$Revision$"
-__Id__       = "$Id: nemo.py 6265 2022-11-02 12:45:56Z omamce $"
+__Id__       = "$Id: $"
 __HeadURL    = "$HeadURL$"
+'''
 
 import numpy as np
@@ -36,12 +39,9 @@
 except ImportError : pass
 
-try    : import f90nml
-except : pass
-
-try : from sklearn.impute import SimpleImputer
-except : pass
-
-try    : import numba
-except : pass
+#try    : import f90nml
+#except : pass
+
+#try : from sklearn.impute import SimpleImputer
+#except : pass
 
 rpi = np.pi ; rad = np.deg2rad (1.0) ; dar = np.rad2deg (1.0)
@@ -61,24 +61,39 @@
 repsi  = np.finfo (1.0).eps
 
-xList = [ 'x', 'X', 'lon'   , 'longitude' ]
-yList = [ 'y', 'Y', 'lat'   , 'latitude'  ]
-zList = [ 'z', 'Z', 'depth' , ]
-tList = [ 't', 'T', 'time'  , ]
+## Default names of dimensions
+dim_names = {'x':'xx', 'y':'yy', 'z':'olevel', 't':None}
+
+## All possibles name of dimensions in Nemo files
+xName = [ 'x', 'X', 'X1', 'xx', 'XX', 'x_grid_T', 'x_grid_U', 'x_grid_V', 'x_grid_F', 'x_grid_W', 'lon', 'nav_lon', 'longitude', 'X1', 'x_c', 'x_f', ]
+yName = [ 'y', 'Y', 'Y1', 'yy', 'YY', 'y_grid_T', 'y_grid_U', 'y_grid_V', 'y_grid_F', 'y_grid_W', 'lat', 'nav_lat', 'latitude' , 'Y1', 'y_c', 'y_f', ]
+zName = [ 'z', 'Z', 'Z1', 'zz', 'ZZ', 'depth', 'tdepth', 'udepth', 'vdepth', 'wdepth', 'fdepth', 'deptht', 'depthu', 'depthv', 'depthw', 'depthf', 'olevel', 'z_c', 'z_f', ]
+tName = [ 't', 'T', 'tt', 'TT', 'time', 'time_counter', 'time_centered', ]
+
+## All possibles name of units of dimensions in Nemo files
+xUnit = [ 'degrees_east', ]
+yUnit = [ 'degrees_north', ]
+zUnit = [ 'm', 'meter', ]
+tUnit = [ 'second', 'minute', 'hour', 'day', 'month', 'year', ]
+
+## All possibles size of dimensions in Orca files
+xLength = [ 180, 182, 360, 362 ]
+yLength = [ 148, 149, 331, 332 ]
+zLength = [31, 75]
 
 ## ===========================================================================
 def __mmath__ (tab, default=None) :
+    '''
+    Determines the type of tab : xarray or numpy object ?
+    '''
     mmath = default
     try    :
         if type (tab) == xr.core.dataarray.DataArray : mmath = xr
-    except :
-        pass
+    except : pass
 
     try    :
         if type (tab) == np.ndarray : mmath = np
-    except :
-        pass
+    except : pass
             
     return mmath
-
 
 def __guessNperio__ (jpj, jpi, nperio=None, out='nperio') :
@@ -99,5 +114,5 @@
     '''
     Tries to guess the value of nperio (periodicity parameter. See NEMO documentation for details)
-    
+
     Inputs
     jpj    : number of latitudes
@@ -105,11 +120,12 @@
     nperio : periodicity parameter
     '''
+    print ( jpi, jpj)
     if nperio == None :
         ## Values for NEMO version < 4.2
-        if jpj ==  149 and jpi ==  182 :
+        if (jpj ==  149 and jpi == 182) or (jpj == None and jpi == 182) or (jpj == 149 or jpi == None) :
             config = 'ORCA2.3'
             nperio = 4   # ORCA2. We choose legacy orca2.
             Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'T'
-        if jpj ==  332 and jpi ==  362 : # eORCA1.
+        if (jpj == 332 and jpi == 362) or (jpj == None and jpi == 362) or (jpj ==  332 and jpi == None) : # eORCA1.
             config = 'eORCA1.2'
             nperio = 6  
@@ -125,9 +141,9 @@
             
         ## Values for NEMO version >= 4.2. No more halo points
-        if jpj == 148 and jpi ==  180 :
+        if (jpj == 148 and jpi == 180) or (jpj == None and jpi == 180) or (jpj == 148 and jpi == None) :
             config = 'ORCA2.4'
             nperio = 4.2 # ORCA2. We choose legacy orca2.
             Iperio = 1 ; Jperio = 0 ; NFold = 1 ; NFtype = 'F'
-        if jpj == 331  and jpi ==  360 : # eORCA1.
+        if (jpj == 331 and jpi == 360) or (jpj == None and jpi == 360) or (jpj == 331 and jpi == None) : # eORCA1.
             config = 'eORCA1.4'
             nperio = 6.2
@@ -142,7 +158,7 @@
         else :
             if nperio in nperio_valid_range :
-                print ('nperio set as {:} (deduced from jpj={:d} jpi={:d})'.format (nperio, jpj, jpi))
+                print ( f'nperio set as {nperio} (deduced from {jpj=} and {jpi=})' )
             else : 
-                raise ValueError ('nperio set as {:} (deduced from jpi={:d}) : nemo.py is not ready for this value'.format (nperio, jpi))
+                raise ValueError ( f'nperio set as {nperio} (deduced from {jpi=} and {jpj=}) : nemo.py is not ready for this value' )
 
     if out == 'nperio' : return nperio
@@ -162,4 +178,5 @@
     Credits : who is the original author ?
     '''
+    
     gP = None
     mmath = __mmath__ (ptab)
@@ -178,9 +195,29 @@
             raise Exception ('in nemo module : cd_type not found, and cannot by guessed')
         else :
-            print ('Grid set as', gP, 'deduced from dims ', ptab.dims)
+            print ( f'Grid set as {gP} deduced from dims {ptab.dims}' )
             return gP
     else :
          raise Exception  ('in nemo module : cd_type not found, input is not an xarray data')
 
+def get_shape ( ptab ) :
+    '''
+    Get shape of ptab : 
+    shape main contain X, Y, Z or T
+    Y is missing for a latitudinal slice
+    X is missing for on longitudinal slice
+    etc ...
+    '''
+    
+    get_shape = ''
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
+    kz, az = __findAxis__ (ptab, 'z')
+    lt, at = __findAxis__ (ptab, 't')
+    if ax : get_shape = 'X'
+    if ay : get_shape = 'Y' + get_shape
+    if az : get_shape = 'Z' + get_shape
+    if at : get_shape = 'T' + get_shape
+    return get_shape
+     
 def lbc_diag (nperio) :
     lperio = nperio ; aperio = False
@@ -190,36 +227,20 @@
         lperio = 6 ; aperio = True
         
-    return lperio, aperio 
+    return lperio, aperio
 
 def __findAxis__ (tab, axis='z') :
     '''
-    Find number and name of the requested axis
+    Find order and name of the requested axis
     '''
     mmath = __mmath__ (tab)
     ix = None ; ax = None
 
-    if axis in xList :
-        axList = [ 'x', 'X',
-                   'lon', 'nav_lon', 'nav_lon_T', 'nav_lon_U', 'nav_lon_V', 'nav_lon_F', 'nav_lon_W',
-                   'x_grid_T', 'x_grid_U', 'x_grid_V', 'x_grid_F', 'x_grid_W',
-                   'glam', 'glamt', 'glamu', 'glamv', 'glamf', 'glamw' ]
-        unList = [ 'degrees_east' ]
-    if axis in yList :
-        axList = [ 'y', 'Y', 'lat',
-                   'nav_lat', 'nav_lat_T', 'nav_lat_U', 'nav_lat_V', 'nav_lat_F', 'nav_lat_W',
-                   'y_grid_T', 'y_grid_U', 'y_grid_V', 'y_grid_F', 'y_grid_W',
-                   'gphi', 'gphi', 'gphiu', 'gphiv', 'gphif', 'gphiw']
-        unList = [ 'degrees_north' ]
-    if axis in zList :
-        axList = [ 'z', 'Z',
-                   'depth', 'deptht', 'depthu', 'depthv', 'depthf', 'depthw',
-                   'olevel' ]
-        unList = [ 'm', 'meter' ]
-    if axis in tList :
-        axList = [ 't', 'T', 'time', 'time_counter' ]
-        unList = [ 'second', 'minute', 'hour', 'day', 'month' ]
+    if axis in xName : axName = xName ; unList = xUnit ; Length = xLength
+    if axis in yName : axName = yName ; unList = yUnit ; Length = yLength
+    if axis in zName : axName = zName ; unList = zUnit ; Length = zLength
+    if axis in tName : axName = tName ; unList = tUnit ; Length = None
     
     if mmath == xr :
-        for Name in axList :
+        for Name in axName :
             try    :
                 ix = tab.dims.index (Name)
@@ -231,19 +252,25 @@
                 for name in unList :
                     if name in tab.coords[dim].attrs['units'] :
-                        ix = i
-                        ax = dim
+                        ix = i ; ax = dim
     else :
-        if axis in xList : ix=-1
-        if axis in yList :
-            if len(tab.shape) >= 2 : ix=-2
-        if axis in zList :
-            if len(tab.shape) >= 3 : ix=-3
-        if axis in tList :
-            if len(tab.shape) >=3  : ix=-3
-            if len(tab.shape) >=4  : ix=-4
+        #if axis in xName : ix=-1
+        #if axis in yName :
+        #    if len(tab.shape) >= 2 : ix=-2
+        #if axis in zName :
+        #    if len(tab.shape) >= 3 : ix=-3
+        #if axis in tName :
+        #    if len(tab.shape) >=3  : ix=-3
+        #    if len(tab.shape) >=4  : ix=-4
+
+        l_shape = tab.shape
+        for nn in np.arange ( len(l_shape)) :
+            if l_shape[nn] in Length : ix = nn
        
     return ix, ax
 
-#@numba.jit(forceobj=True)
+def findAxis ( tab, axis= 'z' ) :
+  ix, xx = __findAxis__ (tab, axis)
+  return xx
+
 def fixed_lon (lon, center_lon=0.0) :
     '''
@@ -277,5 +304,44 @@
     return fixed_lon
 
-#@numba.jit(forceobj=True)
+def bounds_clolon ( bounds_lon, lon, rad=False, deg=True) :
+    '''Choose closest to lon0 longitude, adding or substacting 360Â° if needed'''
+
+    if rad : lon_range = 2.0*np.pi
+    if deg : lon_range = 360.0
+    bounds_clolon = bounds_lon.copy ()
+
+    bounds_clolon = xr.where ( bounds_clolon < lon-lon_range/2., bounds_clolon+lon_range, bounds_clolon )
+    bounds_clolon = xr.where ( bounds_clolon > lon+lon_range/2., bounds_clolon-lon_range, bounds_clolon )
+
+    return bounds_clolon
+
+def UnifyDims ( dd, udims=dim_names, verbose=False ) :
+    '''
+    Rename dimensions to unify them between NEMO versions
+    '''
+    
+    if udims['x'] :
+        for xx in xName :
+            if xx in dd.dims and xx != udims['x'] :
+                if verbose : print ( f"{xx} renamed to {udims['x']}" )
+                dd = dd.rename ( {xx:udims['x']})
+    if udims['y'] :
+        for yy in yName :
+            if yy in dd.dims and yy != udims['y']  :
+                if verbose : print ( f"{yy} renamed to {udims['y']}" )
+                dd = dd.rename ( {yy:udims['y']} )
+    if udims['z'] :
+        for zz in zName :
+            if zz in dd.dims and zz != udims['z'] :
+                if verbose : print ( f"{zz} renamed to {udims['z']}" )
+                dd = dd.rename ( {zz:udims['z']} )
+    if udims['t'] :
+        for tt in tName  :
+            if tt in dd.dims and tt != udims['t'] :
+                if verbose : print ( f"{tt} renamed to {udims['t']}" )
+                dd = dd.rename ( {tt:udims['t']} )
+
+    return dd
+
 def fill_empty (ztab, sval=np.nan, transpose=False) :
     '''
@@ -283,7 +349,8 @@
 
     Useful when NEMO has run with no wet points options : 
-    some parts of the domain, with no ocean points, has no
-    lon/lat values
-    '''
+    some parts of the domain, with no ocean points, have no
+    values
+    '''
+    from sklearn.impute import SimpleImputer
     mmath = __mmath__ (ztab)
 
@@ -302,5 +369,4 @@
     return ptab
 
-#@numba.jit(forceobj=True)
 def fill_lonlat (lon, lat, sval=-1) :
     '''
@@ -308,7 +374,8 @@
 
     Useful when NEMO has run with no wet points options : 
-    some parts of the domain, with no ocean points, as no
+    some parts of the domain, with no ocean points, have no
     lon/lat values
     '''
+    from sklearn.impute import SimpleImputer
     mmath = __mmath__ (lon)
 
@@ -328,5 +395,32 @@
     return plon, plat
 
-#@numba.jit(forceobj=True)
+def fill_bounds_lonlat (bounds_lon, bounds_lat, sval=-1) :
+    '''
+    Fill longitude/latitude bounds values
+
+    Useful when NEMO has run with no wet points options : 
+    some parts of the domain, with no ocean points, as no
+    lon/lat values
+    '''
+    mmath = __mmath__ (bounds_lon)
+
+    p_bounds_lon = np.empty ( bounds_lon.shape )
+    p_bounds_lat = np.empty ( bounds_lat.shape )
+
+    imp = SimpleImputer (missing_values=sval, strategy='mean')
+    
+    for n in np.arange (4) : 
+        imp.fit (bounds_lon[:,:,n])
+        p_bounds_lon[:,:,n] = imp.transform (bounds_lon[:,:,n])
+        imp.fit (bounds_lat[:,:,n].T)
+        p_bounds_lat[:,:,n] = imp.transform (bounds_lat[:,:,n].T).T
+        
+    if mmath == xr :
+        p_bounds_lon = xr.DataArray (bounds_lon, dims=bounds_lon.dims, coords=bounds_lon.coords)
+        p_bounds_lat = xr.DataArray (bounds_lat, dims=bounds_lat.dims, coords=bounds_lat.coords)
+        p_bounds_lon.attrs = bounds_lat.attrs ; p_bounds_lat.attrs = bounds_lat.attrs
+        
+    return p_bounds_lon, p_bounds_lat
+
 def jeq (lat) :
     '''
@@ -337,13 +431,12 @@
     mmath = __mmath__ (lat)
     ix, ax = __findAxis__ (lat, 'x')
-    iy, ay = __findAxis__ (lat, 'y')
+    jy, ay = __findAxis__ (lat, 'y')
 
     if mmath == xr :
-        jeq = int ( np.mean ( np.argmin (np.abs (np.float64 (lat)), axis=iy) ) )
+        jeq = int ( np.mean ( np.argmin (np.abs (np.float64 (lat)), axis=jy) ) )
     else : 
         jeq = np.argmin (np.abs (np.float64 (lat[...,:, 0])))
     return jeq
 
-#@numba.jit(forceobj=True)
 def lon1D (lon, lat=None) :
     '''
@@ -354,21 +447,28 @@
     '''
     mmath = __mmath__ (lon)
-    if np.max (lat) != None :
+    jpj, jpi  = lon.shape [-2:]
+    if np.max (lat) :
         je    = jeq (lat)
-        lon1D = lon.copy() [..., je, :]
+        #lon1D = lon.copy() [..., je, :]
+        lon0 = lon [..., je, 0].copy()
+        dlon = lon [..., je, 1].copy() - lon [..., je, 0].copy()
+        lon1D = np.linspace ( start=lon0, stop=lon0+360.+2*dlon, num=jpi )
     else :
-        jpj, jpi = lon.shape [-2:]
-        lon1D    = lon.copy() [..., jpj//3, :]
-
-    start = np.argmax (np.abs (np.diff (lon1D, axis=-1)) > 180.0, axis=-1)
-    lon1D [..., start+1:] += 360
+        lon0 = lon [..., jpj//3, 0].copy()
+        dlon = lon [..., jpj//3, 1].copy() - lon [..., jpj//3, 0].copy()
+        lon1D = np.linspace ( start=lon0, stop=lon0+360.+2*dlon, num=jpi )
+
+    #start = np.argmax (np.abs (np.diff (lon1D, axis=-1)) > 180.0, axis=-1)
+    #lon1D [..., start+1:] += 360
 
     if mmath == xr :
+        lon1D = xr.DataArray( lon1D, dims=('lon',), coords=(lon1D,))
         lon1D.attrs = lon.attrs
-        lon1D = lon1D.assign_coords ( {'x':lon1D} )
+        lon1D.attrs['units']         = 'degrees_east'
+        lon1D.attrs['standard_name'] = 'longitude'
+        lon1D.attrs['long_name :']   = 'Longitude'
         
     return lon1D
 
-#@numba.jit(forceobj=True)
 def latreg (lat, diff=0.1) :
     '''
@@ -381,6 +481,7 @@
     if diff == None :
         dy   = np.float64 (np.mean (np.abs (lat - np.roll (lat,shift=1,axis=-2, roll_coords=False))))
+        print ( f'{dy=}' )
         diff = dy/100.
-    
+
     je     = jeq (lat)
     jreg   = np.where (lat[...,je:,:].max(axis=-1) - lat[...,je:,:].min(axis=-1)< diff)[-1][-1] + je
@@ -390,5 +491,4 @@
     return jreg, latreg
 
-#@numba.jit(forceobj=True)
 def lat1D (lat) :
     '''
@@ -403,23 +503,32 @@
     je     = jeq (lat)
     lat_eq = np.float64 (lat[...,je,:].mean(axis=-1))
-      
+     
     jreg, lat_reg = latreg (lat)
     lat_ave = np.mean (lat, axis=-1)
 
+    #print ( f'{dy=} {jpj=} {je=} {lat_eq=} {jreg=} ' )
+    
     if (np.abs (lat_eq) < dy/100.) : # T, U or W grid
-        dys    = (90.-lat_reg) / (jpj-jreg-1)*0.5
-        yrange = 90.-dys-lat_reg
+        if jpj-1 > jreg : dys = (90.-lat_reg) / (jpj-jreg-1)*0.5
+        else            : dys = (90.-lat_reg) / 2.0
+        yrange = (90.-dys-lat_reg)
     else                           :  # V or F grid
-        yrange = 90.    -lat_reg
-        
-    lat1D = mmath.where (lat_ave<lat_reg, lat_ave, lat_reg + yrange * (np.arange(jpj)-jreg)/(jpj-jreg-1))   
-        
+        yrange = 90.-lat_reg
+
+    if jpj-1 > jreg :
+        lat1D = mmath.where (lat_ave<lat_reg, lat_ave, lat_reg + yrange * (np.arange(jpj)-jreg)/(jpj-jreg-1) )
+    else :
+        lat1D = lat_ave
+    lat1D[-1] = 90.0
+
     if mmath == xr :
+        lat1D = xr.DataArray( lat1D.values, dims=('lat',), coords=(lat1D,))
         lat1D.attrs = lat.attrs
-        lat1D = lat1D.assign_coords ( {'y':lat1D} )
-
+        lat1D.attrs ['units']         = 'degrees_north'
+        lat1D.attrs ['standard_name'] = 'latitude'
+        lat1D.attrs ['long_name :']   = 'Latitude'
+        
     return lat1D
 
-#@numba.jit(forceobj=True)
 def latlon1D (lat, lon) :
     '''
@@ -430,5 +539,4 @@
     return lat1D (lat),  lon1D (lon, lat)
 
-#@numba.jit(forceobj=True)
 def mask_lonlat (ptab, x0, x1, y0, y1, lon, lat, sval=np.nan) :
     mmath = __mmath__ (ptab)
@@ -445,9 +553,10 @@
     return tab
 
-#@numba.jit(forceobj=True)      
 def extend (tab, Lon=False, jplus=25, jpi=None, nperio=4) :
     '''
     Returns extended field eastward to have better plots, and box average crossing the boundary
     Works only for xarray and numpy data (?)
+
+    Useful for vertical sections in OCE and ATM.
 
     tab : field to extend.
@@ -539,13 +648,17 @@
     See NEMO documentation for further details
     '''
-    jpj, jpi = ptab.shape[-2:]
+    jpi = None ; jpj = None
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
+    if ax : jpi = ptab.shape[ix]
+    if ay : jpj = ptab.shape[jy]
+        
     if nperio == None : nperio = __guessNperio__ (jpj, jpi, nperio)
     
     if nperio not in nperio_valid_range :
-        raise Exception ('nperio=', nperio, ' is not in the valid range', nperio_valid_range)
+        raise Exception ( f'{nperio=} is not in the valid range {nperio_valid_range}' )
 
     return jpj, jpi, nperio
         
-#@numba.jit(forceobj=True)
 def lbc (ptab, nperio=None, cd_type='T', psgn=1.0, nemo_4U_bug=False) :
     '''
@@ -559,4 +672,6 @@
     '''
     jpj, jpi, nperio = lbc_init (ptab, nperio)
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
     psgn   = ptab.dtype.type (psgn)
     mmath = __mmath__ (ptab)
@@ -565,87 +680,89 @@
     else           : ztab = ptab.copy ()
         
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
+    if ax : 
+        #
+        #> East-West boundary conditions
+        # ------------------------------
+        if nperio in [1, 4, 6] :
         # ... cyclic
-        ztab [..., :,  0] = ztab [..., :, -2]
-        ztab [..., :, -1] = ztab [..., :,  1]
-    #
-    #> North-South boundary conditions
-    # --------------------------------
-    if nperio in [3, 4] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, 1:       ] = psgn * ztab [..., -3, -1:0:-1      ]
-            ztab [..., -1, 0        ] = psgn * ztab [..., -3, 2            ]
-            ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2:0:-1  ]
+            ztab [...,  0] = ztab [..., -2]
+            ztab [..., -1] = ztab [...,  1]
+
+        if ay : 
+            #
+            #> North-South boundary conditions
+            # --------------------------------
+            if nperio in [3, 4] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, 1:       ] = psgn * ztab [..., -3, -1:0:-1      ]
+                    ztab [..., -1, 0        ] = psgn * ztab [..., -3, 2            ]
+                    ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2:0:-1  ]
+                    
+                if cd_type == 'U' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]       
+                    ztab [..., -1,  0       ] = psgn * ztab [..., -3,  1           ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -3, -2           ]
+                    
+                    if nemo_4U_bug :
+                        ztab [..., -2, jpi//2+1:-1] = psgn * ztab [..., -2, jpi//2-2:0:-1]
+                        ztab [..., -2, jpi//2-1   ] = psgn * ztab [..., -2, jpi//2       ]
+                    else :
+                        ztab [..., -2, jpi//2-1:-1] = psgn * ztab [..., -2, jpi//2:0:-1]
+                        
+                if cd_type == 'V' : 
+                    ztab [..., -2, 1:       ] = psgn * ztab [..., -3, jpi-1:0:-1   ]
+                    ztab [..., -1, 1:       ] = psgn * ztab [..., -4, -1:0:-1      ]   
+                    ztab [..., -1, 0        ] = psgn * ztab [..., -4, 2            ]
+                    
+                if cd_type == 'F' :
+                    ztab [..., -2, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -4, -1:0:-1      ]
+                    ztab [..., -1,  0       ] = psgn * ztab [..., -4,  1           ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -4, -2           ]
                 
-        if cd_type == 'U' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]       
-            ztab [..., -1,  0       ] = psgn * ztab [..., -3,  1           ]
-            ztab [..., -1, -1       ] = psgn * ztab [..., -3, -2           ]
+            if nperio in [4.2] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, jpi//2:  ] = psgn * ztab [..., -1, jpi//2:0:-1  ]
+                    
+                if cd_type == 'U' :
+                    ztab [..., -1, jpi//2-1:-1] = psgn * ztab [..., -1, jpi//2:0:-1]
+                    
+                if cd_type == 'V' : 
+                    ztab [..., -1, 1:       ] = psgn * ztab [..., -2, jpi-1:0:-1   ]
+                    
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -1:0:-1      ]
                 
-            if nemo_4U_bug :
-                ztab [..., -2, jpi//2+1:-1] = psgn * ztab [..., -2, jpi//2-2:0:-1]
-                ztab [..., -2, jpi//2-1   ] = psgn * ztab [..., -2, jpi//2       ]
-            else :
-                ztab [..., -2, jpi//2-1:-1] = psgn * ztab [..., -2, jpi//2:0:-1]
-                
-        if cd_type == 'V' : 
-            ztab [..., -2, 1:       ] = psgn * ztab [..., -3, jpi-1:0:-1   ]
-            ztab [..., -1, 1:       ] = psgn * ztab [..., -4, -1:0:-1      ]   
-            ztab [..., -1, 0        ] = psgn * ztab [..., -4, 2            ]
-                
-        if cd_type == 'F' :
-            ztab [..., -2, 0:-1     ] = psgn * ztab [..., -3, -1:0:-1      ]
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -4, -1:0:-1      ]
-            ztab [..., -1,  0       ] = psgn * ztab [..., -4,  1           ]
-            ztab [..., -1, -1       ] = psgn * ztab [..., -4, -2           ]
-
-    if nperio in [4.2] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, jpi//2:  ] = psgn * ztab [..., -1, jpi//2:0:-1  ]
-                
-        if cd_type == 'U' :
-            ztab [..., -1, jpi//2-1:-1] = psgn * ztab [..., -1, jpi//2:0:-1]
-                
-        if cd_type == 'V' : 
-            ztab [..., -1, 1:       ] = psgn * ztab [..., -2, jpi-1:0:-1   ]
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -1:0:-1      ]
-
-    if nperio in [5, 6] :            #  North fold F-point pivot  
-        if cd_type in ['T', 'W']  :
-            ztab [..., -1, 0:       ] = psgn * ztab [..., -2, -1::-1       ]
-                
-        if cd_type == 'U' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -2::-1       ]       
-            ztab [..., -1, -1       ] = psgn * ztab [..., -2, 0            ] # Bug ?
-                
-        if cd_type == 'V' :
-            ztab [..., -1, 0:       ] = psgn * ztab [..., -3, -1::-1       ]
-            ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2-1::-1 ]
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -2::-1       ]
-            ztab [..., -1, -1       ] = psgn * ztab [..., -3, 0            ]
-            ztab [..., -2, jpi//2:-1] = psgn * ztab [..., -2, jpi//2-2::-1 ]
-
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
-        # ... cyclic
-        ztab [..., :,  0] = ztab [..., :, -2]
-        ztab [..., :, -1] = ztab [..., :,  1]
+            if nperio in [5, 6] :            #  North fold F-point pivot  
+                if cd_type in ['T', 'W']  :
+                    ztab [..., -1, 0:       ] = psgn * ztab [..., -2, -1::-1       ]
+                    
+                if cd_type == 'U' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -2, -2::-1       ]       
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -2, 0            ] # Bug ?
+                    
+                if cd_type == 'V' :
+                    ztab [..., -1, 0:       ] = psgn * ztab [..., -3, -1::-1       ]
+                    ztab [..., -2, jpi//2:  ] = psgn * ztab [..., -2, jpi//2-1::-1 ]
+                    
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = psgn * ztab [..., -3, -2::-1       ]
+                    ztab [..., -1, -1       ] = psgn * ztab [..., -3, 0            ]
+                    ztab [..., -2, jpi//2:-1] = psgn * ztab [..., -2, jpi//2-2::-1 ]
+                    
+            #
+            #> East-West boundary conditions
+            # ------------------------------
+            if nperio in [1, 4, 6] :
+                # ... cyclic
+                ztab [...,  0] = ztab [..., -2]
+                ztab [..., -1] = ztab [...,  1]
 
     if mmath == xr :
-        ztab = xr.DataArray ( ztab, dims=ptab.dims, coords=ptab.coords)
+        ztab = xr.DataArray ( ztab, dims=ptab.dims, coords=ptab.coords )
         ztab.attrs = ptab.attrs
         
     return ztab
 
-#@numba.jit(forceobj=True)
 def lbc_mask (ptab, nperio=None, cd_type='T', sval=np.nan) :
     #
@@ -659,73 +776,76 @@
     '''
     jpj, jpi, nperio = lbc_init (ptab, nperio)
+    ix, ax = __findAxis__ (ptab, 'x')
+    jy, ay = __findAxis__ (ptab, 'y')
     ztab = ptab.copy ()
 
-    #
-    #> East-West boundary conditions
-    # ------------------------------
-    if nperio in [1, 4, 6] :
+    if ax : 
+        #
+        #> East-West boundary conditions
+        # ------------------------------
+        if nperio in [1, 4, 6] :
         # ... cyclic
-        ztab [..., :,  0] = sval
-        ztab [..., :, -1] = sval
-
-    #
-    #> South (in which nperio cases ?)
-    # --------------------------------
-    if nperio in [1, 3, 4, 5, 6] :
-        ztab [..., 0, :] = sval
-        
-    #
-    #> North-South boundary conditions
-    # --------------------------------
-    if nperio in [3, 4] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1,  :         ] = sval
-            ztab [..., -2, :jpi//2  ] = sval
+            ztab [...,  0] = sval
+            ztab [..., -1] = sval
+
+        if ay : 
+            #
+            #> South (in which nperio cases ?)
+            # --------------------------------
+            if nperio in [1, 3, 4, 5, 6] :
+                ztab [..., 0, :] = sval
+        
+            #
+            #> North-South boundary conditions
+            # --------------------------------
+            if nperio in [3, 4] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1,  :         ] = sval
+                    ztab [..., -2, :jpi//2  ] = sval
                 
-        if cd_type == 'U' :
-            ztab [..., -1,  :         ] = sval  
-            ztab [..., -2, jpi//2+1:  ] = sval
+                if cd_type == 'U' :
+                    ztab [..., -1,  :         ] = sval  
+                    ztab [..., -2, jpi//2+1:  ] = sval
                 
-        if cd_type == 'V' :
-            ztab [..., -2, :       ] = sval
-            ztab [..., -1, :       ] = sval   
-                
-        if cd_type == 'F' :
-            ztab [..., -2, :       ] = sval
-            ztab [..., -1, :       ] = sval
-
-    if nperio in [4.2] :  # North fold T-point pivot
-        if cd_type in [ 'T', 'W' ] : # T-, W-point
-            ztab [..., -1, jpi//2  :  ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, jpi//2-1:-1] = sval
-                
-        if cd_type == 'V' : 
-            ztab [..., -1, 1:       ] = sval
-                
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1     ] = sval
-    
-    if nperio in [5, 6] :            #  North fold F-point pivot
-        if cd_type in ['T', 'W']  :
-            ztab [..., -1, 0:       ] = sval
-                
-        if cd_type == 'U' :
-            ztab [..., -1, 0:-1     ] = sval       
-            ztab [..., -1, -1       ] = sval
-             
-        if cd_type == 'V' :
-            ztab [..., -1, 0:       ] = sval
-            ztab [..., -2, jpi//2:  ] = sval
-                             
-        if cd_type == 'F' :
-            ztab [..., -1, 0:-1       ] = sval
-            ztab [..., -1, -1         ] = sval
-            ztab [..., -2, jpi//2+1:-1] = sval
+                if cd_type == 'V' :
+                    ztab [..., -2, :       ] = sval
+                    ztab [..., -1, :       ] = sval   
+
+                if cd_type == 'F' :
+                    ztab [..., -2, :       ] = sval
+                    ztab [..., -1, :       ] = sval
+
+            if nperio in [4.2] :  # North fold T-point pivot
+                if cd_type in [ 'T', 'W' ] : # T-, W-point
+                    ztab [..., -1, jpi//2  :  ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, jpi//2-1:-1] = sval
+
+                if cd_type == 'V' : 
+                    ztab [..., -1, 1:       ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1     ] = sval
+
+            if nperio in [5, 6] :            #  North fold F-point pivot
+                if cd_type in ['T', 'W']  :
+                    ztab [..., -1, 0:       ] = sval
+
+                if cd_type == 'U' :
+                    ztab [..., -1, 0:-1     ] = sval       
+                    ztab [..., -1, -1       ] = sval
+
+                if cd_type == 'V' :
+                    ztab [..., -1, 0:       ] = sval
+                    ztab [..., -2, jpi//2:  ] = sval
+
+                if cd_type == 'F' :
+                    ztab [..., -1, 0:-1       ] = sval
+                    ztab [..., -1, -1         ] = sval
+                    ztab [..., -2, jpi//2+1:-1] = sval
 
     return ztab
 
-#@numba.jit(forceobj=True)
 def lbc_plot (ptab, nperio=None, cd_type='T', psgn=1.0, sval=np.nan) :
     '''
